<div class="ddp-wrap-shelf">
  <!-- shelf -->
  <div id="shelfColumn1" class="ddp-ui-shelf" [ngClass]="{'ddp-add-self' : layerNum === 1}">
    <em *ngIf="'network' !== chartType" class="ddp-icon-mapview1"></em>
    <em *ngIf="'network' == chartType" class="ddp-icon-network ddp-source"></em>
    <!-- drag slide -->
    <div class="ddp-ui-drag-slide">
      <a (mouseover)="mouseOverPrev($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-prev" style="display: none;"><em class="ddp-icon-prev"></em></a>
      <a (mouseover)="mouseOverNext($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-next" style="display: none"><em class="ddp-icon-next"></em></a>
      <div class="ddp-slide-control">
          <a href="javascript:" class="ddp-btn-plus" (click)="changeLayer(2)" *ngIf="layerNum === 1"></a>
      </div>
      <div class="ddp-ui-drag-slide-in">

        <div class="ddp-wrap-default" [dragula]="'dragbag'" [dragulaModel]="pivot.columns" [attr.data-container]="'column'">
          <!-- box shelf -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType == '' && pivot.columns.length == 0">
            <div class="ddp-box-shelf">
              {{'msg.page.ui.place.data' | translate}}
            </div>
          </div>
          <!-- //box shelf -->
          <!-- 예시 -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType != '' && unavailableShelfs.indexOf('column') > -1">
            <div class="ddp-box-unavailable">
              {{'msg.page.ui.unavailable.shelf' | translate}}
            </div>
          </div>
          <!-- //예시 -->
          <!-- Pivot -->
          <div class="ddp-ui-default" *ngFor="let field of pivot.columns; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === undefined || field.layerNum === 1" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.columns.slice(i, i+1)[0]">
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="field.name != field.pivotAlias && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!-- //aggregation type -->
              <!-- geo-point type -->
              <em class="ddp-icon-point-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POINT' == field.field.logicalType"></em>
              <!-- //geo-point type -->
              <!-- geo-line type -->
              <em class="ddp-icon-line-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_LINE' == field.field.logicalType"></em>
              <!-- //geo-line type -->
              <!-- geo-polygon type -->
              <em class="ddp-icon-polygon-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POLYGON' == field.field.logicalType"></em>
              <!-- //geo-polygon type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'COLUMNS', pivot.columns, i)"><em></em></span>
              </div>
            </a>
          </div>

          <div class="ddp-ui-default" *ngFor="let field of pivot.aggregations; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === undefined || field.layerNum === 1" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.aggregations.slice(i, i+1)[0]"
            >
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="(!field.pivotAlias || field.name == field.pivotAlias) && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!--<span class="ddp-type-value" *ngIf="field.aggregationType && field.alias == field.name">{{field.aggregationType}}</span>-->
              <!-- //aggregation type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'AGGREGATIONS', pivot.aggregations, i)"><em></em></span>
              </div>
            </a>
          </div>
          <!-- //Pivot -->
          <!-- Guide -->
          <div *ngIf="isGuide('columns')" class="dragIgnore ddp-wrap-example">
            <div [attr.class]="getGuideText('columns', false)">
              {{getGuideText('columns')}}
            </div>
          </div>
          <!-- //Guide -->
        </div>
      </div>
    </div>
    <!-- //drag slide -->
  </div>
  <!-- //shelf -->

  <!-- shelf2 -->
  <div id="shelfColumn2" class="ddp-ui-shelf"  [ngClass]="{'ddp-add-self' : layerNum === 2}" *ngIf="layerNum > 1">
    <em *ngIf="'network' !== chartType" class="ddp-icon-mapview2"></em>
    <em *ngIf="'network' == chartType" class="ddp-icon-network ddp-source"></em>
    <!-- drag slide -->
    <div class="ddp-ui-drag-slide">
      <a (mouseover)="mouseOverPrev($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-prev" style="display: none;"><em class="ddp-icon-prev"></em></a>
      <a (mouseover)="mouseOverNext($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-next" style="display: none"><em class="ddp-icon-next"></em></a>
      <div class="ddp-slide-control">
          <a href="javascript:" class="ddp-btn-plus" (click)="changeLayer(3)"  *ngIf="layerNum === 2"></a>
          <a href="javascript:" class="ddp-btn-minus" (click)="changeLayer(1)"  *ngIf="layerNum === 2"></a>
      </div>
      <div class="ddp-ui-drag-slide-in">

        <div class="ddp-wrap-default" [dragula]="'dragbag'" [dragulaModel]="pivot.columns" [attr.data-container]="'column'">
          <!-- box shelf -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType == '' && pivot.columns.length == 0">
            <div class="ddp-box-shelf">
              {{'msg.page.ui.place.data' | translate}}
            </div>
          </div>
          <!-- //box shelf -->
          <!-- 예시 -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType != '' && unavailableShelfs.indexOf('column') > -1">
            <div class="ddp-box-unavailable">
              {{'msg.page.ui.unavailable.shelf' | translate}}
            </div>
          </div>
          <!-- //예시 -->
          <!-- Pivot -->
          <div class="ddp-ui-default" *ngFor="let field of pivot.columns; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === 2" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.columns.slice(i, i+1)[0]">
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="field.name != field.pivotAlias && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!-- //aggregation type -->
              <!-- geo-point type -->
              <em class="ddp-icon-point-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POINT' == field.field.logicalType"></em>
              <!-- //geo-point type -->
              <!-- geo-line type -->
              <em class="ddp-icon-line-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_LINE' == field.field.logicalType"></em>
              <!-- //geo-line type -->
              <!-- geo-polygon type -->
              <em class="ddp-icon-polygon-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POLYGON' == field.field.logicalType"></em>
              <!-- //geo-polygon type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'COLUMNS', pivot.columns, i)"><em></em></span>
              </div>
            </a>
          </div>

          <div class="ddp-ui-default" *ngFor="let field of pivot.aggregations; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === 2" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.aggregations.slice(i, i+1)[0]"
            >
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="(!field.pivotAlias || field.name == field.pivotAlias) && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!--<span class="ddp-type-value" *ngIf="field.aggregationType && field.alias == field.name">{{field.aggregationType}}</span>-->
              <!-- //aggregation type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'AGGREGATIONS', pivot.aggregations, i)"><em></em></span>
              </div>
            </a>
          </div>
          <!-- //Pivot -->
          <!-- Guide -->
          <div *ngIf="isGuide('columns')" class="dragIgnore ddp-wrap-example">
            <div [attr.class]="getGuideText('columns', false)">
              {{getGuideText('columns')}}
            </div>
          </div>
          <!-- //Guide -->
        </div>
      </div>
    </div>
    <!-- //drag slide -->
  </div>
  <!-- //shelf2 -->

  <!-- shelf3 -->
  <div id="shelfColumn3" class="ddp-ui-shelf"  [ngClass]="{'ddp-add-self' : layerNum === 3}" *ngIf="layerNum > 2">
    <em *ngIf="'network' !== chartType" class="ddp-icon-mapview3"></em>
    <em *ngIf="'network' == chartType" class="ddp-icon-network ddp-source"></em>
    <!-- drag slide -->
    <div class="ddp-ui-drag-slide">
      <a (mouseover)="mouseOverPrev($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-prev" style="display: none;"><em class="ddp-icon-prev"></em></a>
      <a (mouseover)="mouseOverNext($event)" (mouseout)="animationPause = true" href="javascript:" class="ddp-btn-next" style="display: none"><em class="ddp-icon-next"></em></a>
      <div class="ddp-slide-control">
          <a href="javascript:" class="ddp-btn-minus" (click)="changeLayer(2)"></a>
      </div>
      <div class="ddp-ui-drag-slide-in">

        <div class="ddp-wrap-default" [dragula]="'dragbag'" [dragulaModel]="pivot.columns" [attr.data-container]="'column'">
          <!-- box shelf -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType == '' && pivot.columns.length == 0">
            <div class="ddp-box-shelf">
              {{'msg.page.ui.place.data' | translate}}
            </div>
          </div>
          <!-- //box shelf -->
          <!-- 예시 -->
          <div class="dragIgnore ddp-wrap-example" *ngIf="chartType != '' && unavailableShelfs.indexOf('column') > -1">
            <div class="ddp-box-unavailable">
              {{'msg.page.ui.unavailable.shelf' | translate}}
            </div>
          </div>
          <!-- //예시 -->
          <!-- Pivot -->
          <div class="ddp-ui-default" *ngFor="let field of pivot.columns; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === 3" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.columns.slice(i, i+1)[0]">
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="field.name != field.pivotAlias && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!-- //aggregation type -->
              <!-- geo-point type -->
              <em class="ddp-icon-point-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POINT' == field.field.logicalType"></em>
              <!-- //geo-point type -->
              <!-- geo-line type -->
              <em class="ddp-icon-line-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_LINE' == field.field.logicalType"></em>
              <!-- //geo-line type -->
              <!-- geo-polygon type -->
              <em class="ddp-icon-polygon-w ddp-icon-map-view-w" *ngIf="field.field.logicalType && 'GEO_POLYGON' == field.field.logicalType"></em>
              <!-- //geo-polygon type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'COLUMNS', pivot.columns, i)"><em></em></span>
              </div>
            </a>
          </div>

          <div class="ddp-ui-default" *ngFor="let field of pivot.aggregations; let i = index" [ngStyle]="{display: finishAnimation ? 'block' : 'none'}">
            <a *ngIf="field.layerNum === 3" href="javascript:" unselectable="on"
               [class.ddp-ui-dimension-wrap]="field.type == 'dimension' || field.type == 'timestamp'"
               [class.ddp-ui-measure-wrap]="field.type == 'measure'"
               (mousedown)="dragField = pivot.aggregations.slice(i, i+1)[0]"
            >
              <!-- timestamp type -->
              <span class="ddp-type-value" *ngIf="field.type && 'timestamp' === field.type">{{getGranularityName(field)}}</span>
              <!-- //timestamp type -->
              <!-- aggregation type -->
              <span class="ddp-type-value" *ngIf="(!field.pivotAlias || field.name == field.pivotAlias) && 'measure' == field.type && ((field.aggregationType && 'user_expr' !== field.subType) || (!field.aggregated && 'user_expr' == field.subType))">{{field.aggregationType}}</span>
              <!--<span class="ddp-type-value" *ngIf="field.aggregationType && field.alias == field.name">{{field.aggregationType}}</span>-->
              <!-- //aggregation type -->
              <span class="ddp-data">{{getDisplayPivotName(field)}}</span>
              <div class="ddp-ui-icons">
                <em class="ddp-icon-control-calculat" *ngIf="field.subType == 'user_expr' && field.type == 'measure'"></em>
                <em class="ddp-icon-control-user" *ngIf="field.subType == 'user_expr' && field.type == 'dimension'"></em>
                <span class="ddp-icon-layer" [class.ddp-selected]="editingField == field" (click)="openFieldSetting($event, field)"><em></em></span>
                <span class="ddp-icon-close" (click)="removeField($event, 'AGGREGATIONS', pivot.aggregations, i)"><em></em></span>
              </div>
            </a>
          </div>
          <!-- //Pivot -->
          <!-- Guide -->
          <div *ngIf="isGuide('columns')" class="dragIgnore ddp-wrap-example">
            <div [attr.class]="getGuideText('columns', false)">
              {{getGuideText('columns')}}
            </div>
          </div>
          <!-- //Guide -->
        </div>
      </div>
    </div>
    <!-- //drag slide -->
  </div>
  <!-- //shelf3 -->






</div>

<div #editFieldLayer id="editFieldLayer" class="ddp-ui-layer-box" [style.display]="editingField == null ? 'none' : 'block'" (clickOutside)="editingField=null; fix2DepthContext = false;" [excludeBeforeClick]="true" [exclude]="'.ddp-icon-layer'">
  <div *ngIf="editingField">
    <div class="ddp-ui-layer-title">
      {{editingField.name}}
    </div>
    <ul class="ddp-list-layer-option ddp-list-radio">
      <li *ngIf="editingField.field.logicalType && editingField.field.logicalType.indexOf('GEO') != 0">
        <a href="javascript:">
          <label class="ddp-label-toggle">
            {{'msg.page.th.filter' | translate}}
            <input (change)="onChangeFilter($event)"
                   [checked]="filterFiledList.indexOf(editingField.name) != -1"
                   type="checkbox"/>
            <span class="ddp-txt-toggle">
                <i class="ddp-icon-checked"></i>
            </span>
          </label>
        </a>
      </li>

      <li [class.ddp-hover]="fix2DepthContext">
        <a (mouseover)="setEditingFieldAlias( editingField );" href="javascript:">
          {{'msg.page.th.alias-this-chart' | translate}}
          <div class="ddp-data-result">
            {{getDisplayEditingPivotAlias( editingField )}} <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth (알라ㅣ아스 있을 경우) -->
        <div class="ddp-ui-layer-sub">
          <div class="ddp-box-layer">
            <input [(ngModel)]="editingFieldAlias" type="text" class="ddp-input-typebasic"
                   placeholder="{{getAliasPlaceholder(editingField)}}"
                   (focus)="fix2DepthContext = true;"
                   (keyup.enter)="onAliasApply($event)"/>
            <a *ngIf="isSetPivotAlias(editingField)"
               (click)="onAliasReset($event)"
               href="javascript:"
               class="ddp-btn-line">{{'msg.page.btn.reset' | translate}}</a>
            <a href="javascript:"
               (click)="onAliasApply($event)"
               [class.ddp-full]="!isSetPivotAlias(editingField)"
               class="ddp-btn-solid">{{'msg.page.btn.apply' | translate}}</a>
          </div>
        </div>
        <!-- //2depth -->
      </li>
      <li *ngIf="editingField.subType == 'user_expr'">
        <a href="javascript:">
          {{'msg.page.th.edit-cond' | translate}}
          <div class="ddp-data-result">
            <span class="ddp-txt-result">{{unescapeCustomColumnExpr(editingField.field.expr)}}</span>
            <em (click)="customFieldEvent.emit(editingField.field)" class="ddp-btn-option"></em>
          </div>
        </a>
      </li>
      <li *ngIf="editingField.field.logicalType && editingField.field.logicalType.indexOf('GEO') != 0 && ['timestamp'].indexOf(editingField.type) == -1" (mouseover)="fix2DepthContext = false;">
        <a href="javascript:">
          {{'msg.page.th.align' | translate}}
          <div class="ddp-data-result ddp-type">
            {{getAlignName()}}
            <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth -->
        <div class="ddp-ui-layer-sub">
          <ul class="ddp-list-popup">
            <li (click)="onChangeOrder('NONE')" [class.ddp-selected]="hasAlign('NONE')">
              <a href="javascript:">
                {{'msg.page.li.data.order' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeOrder('ASC')" [class.ddp-selected]="hasAlign('ASC')">
              <a href="javascript:">
                {{'msg.page.li.asc' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeOrder('DESC')" [class.ddp-selected]="hasAlign('DESC')">
              <a href="javascript:">
                {{'msg.page.li.desc' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
          </ul>
        </div>
        <!-- //2depth -->
      </li>
      <li *ngIf="editingField.type == 'measure' && !editingField.aggregated" (mouseover)="fix2DepthContext = false;">
        <a href="javascript:">
          {{'msg.page.th.aggregate' | translate}}
          <div class="ddp-data-result ddp-type">
            {{editingField.aggregationType}}
            <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth -->
        <div class="ddp-ui-layer-sub">
          <ul class="ddp-list-popup">
            <li *ngFor="let aggType of aggTypeList"
                [class.ddp-selected]="aggType['id'] == editingField.aggregationType && 'PERCENTILE' !== editingField.aggregationType"
                (click)="onChangeAggregationType(aggType['id'])"
                [class.ddp-disabled]="-1 !== editingField.aggregationTypeList.indexOf(aggType['id'])">
              <a href="javascript:">
                {{aggType['label']}}
                <em *ngIf="'PERCENTILE' !== aggType['id']" class="ddp-icon-check"></em>

                <div *ngIf="'PERCENTILE' === aggType['id']" class="ddp-data-result ddp-type">
                  {{'PERCENTILE' !== editingField.aggregationType ? '' : editingField.options && -1 !== editingField.options.indexOf(0.25) ? '1/4' : '3/4'}}
                  <em class="ddp-icon-view"></em>
                </div>
              </a>

              <!-- PERCENTILE일떄 3depth show-->
              <div *ngIf="'PERCENTILE' === aggType['id']" class="ddp-ui-layer-sub">
                <ul class="ddp-list-popup">
                  <li *ngFor="let item of aggType['options']"
                      (click)="onChangeAggregationType(aggType['id'], item.decimal)"
                      [class.ddp-selected]="'PERCENTILE' === editingField.aggregationType && editingField.options && -1 !== editingField.options.indexOf('value')? editingField.options.indexOf(item.decimal) !== -1 : false"
                      [class.ddp-disabled]="-1 !== editingField.aggregationTypeList.indexOf(aggType['id'])">
                    <a href="javascript:">
                      {{item.fraction}}
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                </ul>
              </div>
              <!-- //3depth -->
            </li>
          </ul>
        </div>
        <!-- //2depth -->
      </li>
      <li *ngIf="chartType == 'combine' && editingField.type == 'measure'" (mouseover)="fix2DepthContext = false;">
        <a href="javascript:">
          {{'msg.page.th.vslztn' | translate}}
          <div class="ddp-data-result ddp-type">
            {{!editingField || !editingField?.options ? combineAggIndex % 2 == 0 ? 'Bar' : 'Line' : -1 !== editingField.options.indexOf('bar') ? 'Bar' : 'Line'}}
            <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth -->
        <div class="ddp-ui-layer-sub">
          <ul class="ddp-list-popup">
            <li (click)="combineChangeSeriesConvertType('bar')" [ngClass]="{'ddp-selected' : !editingField || !editingField?.options ? combineAggIndex % 2 == 0 : -1 !== editingField.options.indexOf('bar')}">
              <a href="javascript:">
                {{'msg.page.li.bar' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="combineChangeSeriesConvertType('line')" [ngClass]="{'ddp-selected' : !editingField || !editingField?.options ? combineAggIndex % 2 !== 0 : -1 !== editingField.options.indexOf('line')}">
              <a href="javascript:">
                {{'msg.page.li.line' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
          </ul>
        </div>
        <!-- //2depth -->
      </li>
      <li *ngIf="!uiOption.split && editingField.type == 'measure'" (mouseover)="fix2DepthContext = false;">
        <a href="javascript:">
          {{'msg.page.th.format' | translate}}
          <div class="ddp-data-result ddp-type">
            {{
            !editingField.format ? '' :
            editingField.format.type == 'number' ? ('msg.page.li.num' | translate) :
            editingField.format.type == 'currency' ? ('msg.page.li.currency' | translate) :
            editingField.format.type == 'percent' ? ('msg.page.li.percent' | translate) :
            editingField.format.type == 'exponent10' ? ('msg.page.th.exponential.form' | translate) : ''
            }}
            <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth -->
        <div class="ddp-ui-layer-sub">
          <ul class="ddp-list-popup">
            <li (click)="onChangeFormat('number')" [class.ddp-selected]="editingField.format && editingField.format.type == 'number'">
              <a href="javascript:">
                {{'msg.page.li.num' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeFormat('currency')" [class.ddp-selected]="editingField.format && editingField.format.type == 'currency'">
              <a href="javascript:">
                {{'msg.page.li.currency' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeFormat('percent')" [class.ddp-selected]="editingField.format && editingField.format.type == 'percent'">
              <a href="javascript:">
                {{'msg.page.li.percent' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeFormat('exponent10')" [class.ddp-selected]="editingField.format && editingField.format.type == 'exponent10'">
              <a href="javascript:">
                {{'msg.page.th.exponential.form' | translate}}
                <em class="ddp-icon-check"></em>
              </a>
            </li>
            <li (click)="onChangeFormat('')">
              <a href="javascript:">
                {{'msg.page.li.detail-settings' | translate}}
                <em class="ddp-btn-option"></em>
              </a>
            </li>
          </ul>
        </div>
        <!-- //2depth -->
      </li>
      <li *ngIf="false && ['measure', 'FIXME-측정값기타'].indexOf(editingField.type ) > -1">
        <a href="javascript:">
          <label class="ddp-label-toggle">
            {{'msg.page.chart.show.value.on.chart' | translate}}
            <input (change)="onChangeShowValue($event.target.checked)"
                   [(ngModel)]="editingField.showValue"
                   type="checkbox"/>
            <span class="ddp-txt-toggle">
                 <i class="ddp-icon-checked"></i>
             </span>
          </label>
        </a>
      </li>
      <li *ngIf="false && (editingField.type == 'measure' && isPossibleSeries())">
        <a href="javascript:">
          <label class="ddp-label-toggle">
            {{'msg.page.chart.set.secondary.axis' | translate}}
            <input (change)="onChangeSecondaryAxis($event)"
                   [checked]="isSecondaryAxis()"
                   type="checkbox"/>
            <span class="ddp-txt-toggle">
                <i class="ddp-icon-checked"></i>
            </span>
          </label>
        </a>
      </li>
      <li *ngIf="editingField.type == 'timestamp'" (mouseover)="fix2DepthContext = false;">
        <a href="javascript:">
          {{'msg.page.th.gran' | translate}}
          <div class="ddp-data-result ddp-type">
            {{getGranularityName(editingField, true)}}
            <em class="ddp-icon-view"></em>
          </div>
        </a>
        <!-- 2depth -->
        <div class="ddp-ui-layer-sub ddp-type">
          <div class="ddp-ui-layer-title">
            {{'msg.page.ui.formula' | translate}}
          </div>
          <ul class="ddp-list-popup">
            <!-- 초단위 제거 요청으로 주석처리 -->
            <!--<li (click)="onChangeGranularity(false, 'SECOND')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'SECOND')"-->
                <!--*ngIf="isUseGranularity(false, 'SECOND')"-->
                <!--[class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('SECOND')">-->
              <!--<a href="javascript:">-->
                <!--{{'msg.page.li.second' | translate}}-->
                <!--<div class="ddp-data-info">-->
                  <!--May 8, 2015 14:05:30-->
                <!--</div>-->
              <!--</a>-->
            <!--</li>-->
            <!-- //초단위 제거 요청으로 주석처리 -->
            <li (click)="onChangeGranularity(false, 'MINUTE')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'MINUTE')"
                *ngIf="isUseGranularity(false, 'MINUTE')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MINUTE')">
              <a href="javascript:">
                {{'msg.page.li.minute' | translate}}
                <div class="ddp-data-info">
                  May 8, 2015 14:05
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(false, 'HOUR')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'HOUR')"
                *ngIf="isUseGranularity(false, 'HOUR')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('HOUR')">
              <a href="javascript:">
                {{'msg.page.li.hour' | translate}}
                <div class="ddp-data-info">
                  May 8, 2015 14:00
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(false, 'DAY')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'DAY')"
                *ngIf="isUseGranularity(false, 'DAY')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('DAY')">
              <a href="javascript:">
                {{'msg.page.li.day' | translate}}
                <div class="ddp-data-info">
                  May 8, 2015
                </div>
              </a>
            </li>
            <!--
            <li (click)="onChangeGranularity(false, 'WEEK')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'WEEK')"
                *ngIf="isUseGranularity(false, 'WEEK')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('WEEK')">
              <a href="javascript:">
                {{'msg.page.li.week' | translate}}
                <div class="ddp-data-info">
                  May 8, 2015
                </div>
              </a>
            </li>
            -->
            <li (click)="onChangeGranularity(false, 'MONTH')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'MONTH')"
                *ngIf="isUseGranularity(false, 'MONTH')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MONTH')">
              <a href="javascript:">
                {{'msg.page.li.month' | translate}}
                <div class="ddp-data-info">
                  May 2015
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(false, 'QUARTER')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'QUARTER')"
                *ngIf="isUseGranularity(false, 'QUARTER')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('QUARTER')">
              <a href="javascript:">
                {{'msg.page.li.quarter' | translate}}
                <div class="ddp-data-info">
                  Q2 2015
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(false, 'YEAR')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'YEAR')"
                *ngIf="isUseGranularity(false, 'YEAR')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('YEAR')">
              <a href="javascript:">
                {{'msg.page.li.year' | translate}}
                <div class="ddp-data-info">
                  2015
                </div>
              </a>
            </li>

            <li (click)="onChangeGranularity(false, 'NONE')" [class.ddp-selected]="isGranularitySelected(editingField, false, 'NONE')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('NONE')">
              <a href="javascript:">
                {{'msg.page.li.none' | translate}}
              </a>
            </li>

          </ul>

          <div class="ddp-ui-layer-title">
            {{'msg.page.ui.discon.type' | translate}}
          </div>
          <ul class="ddp-list-popup">
            <!-- 초단위 제거 요청으로 주석처리 -->
            <!--<li (click)="onChangeGranularity(true, 'SECOND')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'SECOND')"-->
                <!--*ngIf="isUseGranularity(true, 'SECOND')"-->
                <!--[class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('SECOND')">-->
              <!--<a href="javascript:">-->
                <!--{{'msg.page.li.second' | translate}}-->
                <!--<div class="ddp-data-info">-->
                  <!--14:05:30 (by minute)-->
                <!--</div>-->
              <!--</a>-->
            <!--</li>-->
            <!-- //초단위 제거 요청으로 주석처리 -->
            <li (click)="onChangeGranularity(true, 'MINUTE')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'MINUTE')"
                *ngIf="isUseGranularity(true, 'MINUTE')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MINUTE')">
              <a href="javascript:">
                {{'msg.page.li.minute' | translate}}
                <div class="ddp-data-info">
                  14:05 (by hour)
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(true, 'HOUR')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'HOUR')"
                *ngIf="isUseGranularity(true, 'HOUR')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('HOUR')">
              <a href="javascript:">
                {{'msg.page.li.hour' | translate}}
                <div class="ddp-data-info">
                  14:00 (by day)
                </div>
              </a>
            </li>
            <li [class.ddp-selected]="isGranularitySelected(editingField, true, 'DAY')"
                *ngIf="isUseGranularity(true, 'DAY')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('DAY')">
              <a href="javascript:">
                {{'msg.page.li.day' | translate}}
                <div class="ddp-data-result ddp-type">
                  Friday (by week)
                  <em class="ddp-icon-view"></em>
                </div>

              </a>
              <!-- 3depth -->
              <div class="ddp-ui-layer-sub">
                <ul class="ddp-list-popup">
                  <li (click)="onChangeGranularity(true, 'DAY', 'WEEK')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'DAY', 'WEEK')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('DAY')">
                    <a href="javascript:">
                      By week
                      <div class="ddp-data-info">
                        Friday
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                  <li (click)="onChangeGranularity(true, 'DAY', 'MONTH')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'DAY', 'MONTH')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('DAY')">
                    <a href="javascript:">
                      By month
                      <div class="ddp-data-info">
                        8
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                  <li (click)="onChangeGranularity(true, 'DAY', 'YEAR')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'DAY', 'YEAR')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('DAY')">
                    <a href="javascript:">
                      By year
                      <div class="ddp-data-info">
                        130
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>

                </ul>
              </div>
              <!-- //3depth -->
            </li>
            <li [class.ddp-selected]="isGranularitySelected(editingField, true, 'WEEK')"
                *ngIf="isUseGranularity(true, 'WEEK')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('WEEK')">
              <a href="javascript:">
                {{'msg.page.li.week' | translate}}
                <div class="ddp-data-result ddp-type">
                  Week 19 (by year)
                  <em class="ddp-icon-view"></em>
                </div>
              </a>
              <!-- 3depth -->
              <div class="ddp-ui-layer-sub">
                <ul class="ddp-list-popup">
                  <li (click)="onChangeGranularity(true, 'WEEK', 'MONTH')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'WEEK', 'MONTH')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('WEEK')">
                    <a href="javascript:">
                      By month
                      <div class="ddp-data-info">
                        Week 1
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                  <li (click)="onChangeGranularity(true, 'WEEK', 'YEAR')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'WEEK', 'YEAR')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('WEEK')">
                    <a href="javascript:">
                      By year
                      <div class="ddp-data-info">
                        Week 19
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                </ul>
              </div>
              <!-- //3depth -->
            </li>
            <li [class.ddp-selected]="isGranularitySelected(editingField, true, 'MONTH')"
                *ngIf="isUseGranularity(true, 'MONTH')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MONTH')">
              <a href="javascript:">
                {{'msg.page.li.month' | translate}}
                <div class="ddp-data-result ddp-type">
                  May (by year)
                  <em class="ddp-icon-view"></em>
                </div>
              </a>
              <!-- 3depth -->
              <div class="ddp-ui-layer-sub">
                <ul class="ddp-list-popup">
                  <!--<li (click)="onChangeGranularity(true, 'MONTH', 'QUARTER')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'MONTH', 'QUARTER')"-->
                      <!--[class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MONTH')">-->
                    <!--<a href="javascript:">-->
                      <!--By quarter-->
                      <!--<div class="ddp-data-info">-->
                        <!--Q2-->
                      <!--</div>-->
                      <!--<em class="ddp-icon-check"></em>-->
                    <!--</a>-->
                  <!--</li>-->
                  <li (click)="onChangeGranularity(true, 'MONTH', 'YEAR')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'MONTH', 'YEAR')"
                      [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('MONTH')">
                    <a href="javascript:">
                      By year
                      <div class="ddp-data-info">
                        May
                      </div>
                      <em class="ddp-icon-check"></em>
                    </a>
                  </li>
                </ul>
              </div>
              <!-- //3depth -->
            </li>
            <li (click)="onChangeGranularity(true, 'QUARTER')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'QUARTER')"
                *ngIf="isUseGranularity(true, 'QUARTER')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('QUARTER')">
              <a href="javascript:">
                {{'msg.page.li.quarter' | translate}}
                <div class="ddp-data-info">
                  Q2 (by year)
                </div>
              </a>
            </li>
            <li (click)="onChangeGranularity(true, 'YEAR')" [class.ddp-selected]="isGranularitySelected(editingField, true, 'YEAR')"
                *ngIf="isUseGranularity(true, 'YEAR')"
                [class.ddp-disabled]="-1 !== editingField.granularityList.indexOf('YEAR')">
              <a href="javascript:">
                {{'msg.page.li.year' | translate}}
                <div class="ddp-data-info">
                  2015
                </div>
              </a>
            </li>
          </ul>
        </div>
        <!-- //2depth -->
      </li>
    </ul>
  </div>
</div>
